
#include <lib.h>

// --------------------------------------
//   LineBench
// --------------------------------------
// (c) 2003 Mickael Pointier.
// This code is provided as-is.
// I do not assume any responsability
// concerning the fact this is a bug-free
// software !!!
// Except that, you can use this example
// without any limitation !
// If you manage to do something with that
// please, contact me :)
// --------------------------------------
// --------------------------------------
// For more information, please contact me
// on internet:
// e-mail: mike@defence-force.org
// URL: http://www.defence-force.org
// --------------------------------------
// Note: This text was typed with a Win32
// editor. So perhaps the text will not be
// displayed correctly with other OS.




extern unsigned char hires_image[];
extern unsigned char hires_image_end[];

// ============================================================================
//
//									Externals
//
// ============================================================================

//
// ===== Display.s =====
//
extern unsigned char CurrentDisplayCode;

extern unsigned char CurrentTool;

extern unsigned char HiresSizePos;		// Position of hires view
extern unsigned char HiresSizeView;		// Size of the the hires view

extern unsigned char PixelDrawMode;		// 0=erase 1=draw 2=invert 3=nothing
extern unsigned char FlagPixelMode;		// 0=byte 1=pixel 
extern unsigned char CurrentPixelX;		// Coordinate X of edited pixel/byte
extern unsigned char CurrentPixelY;		// Coordinate Y of edited pixel/byte

extern unsigned char OtherPixelX;		// Coordinate X of other edited pixel/byte
extern unsigned char OtherPixelY;		// Coordinate Y of other edited pixel/byte

extern unsigned char ToolWidth;
extern unsigned char ToolHeight;

extern unsigned char CurrentZoomPixelBit;
extern unsigned char CurrentZoomPixelX; // X Position of zoomed window pixel         
extern unsigned char CurrentZoomPixelY; // Y Position of zoomed window pixel 

extern unsigned char CurrentZoomX;		// X Position of zoomed window
extern unsigned char CurrentZoomY;		// Y Position of zoomed window
extern unsigned char CurrentLineCount;	// Number of lines in the zoomed window

extern unsigned char TableBit6[];
extern unsigned char TableMul6[];
extern unsigned char TableDiv6[];
extern unsigned char TableMod6[];


extern unsigned char MemorizedByte;
extern unsigned char *PtrCurrentByte;

extern unsigned char FlagRedrawInfos;
extern unsigned char FlagRedrawPicture;
extern unsigned char FlagRedrawZoomer;
extern unsigned char FlagRedrawInverse;

extern unsigned char FlagProtectedAttribute;

extern unsigned char FlagDisplayZoomer;

extern unsigned char KeySpecial;
extern unsigned char KeyScan;




void DoLoad();
void GenerateTables();

void DisplaySeparationLines();
void DisplayPicture();
void DisplayZoomer();
void DisplayPictureFullScreen();

void PictureInvertWindow();

void DisplayInformation();

void DisplayCursorCoordinates();





//
// ===== Buffer.s =====
//
extern unsigned char BufferMain1[];		// Buffer for the main picture

void UndoBufferMemorize();
void UndoBufferSwap();

void BufferErase();
void PictureInvertWindow();
void PaintPixel();

void SwitchToHires();
void SwitchToText();
void ClearTextScreen();


void DrawLine();
void EraseLine();

void DrawTool();
void RestoreToolBackground();



void line_mike()
{
	unsigned char i;
	for (i=0;i<239;i++)
	{
		CurrentPixelX=i;
		CurrentPixelY=0;
		OtherPixelX=239-i;
		OtherPixelY=199;

		DrawLine();
	}
	for (i=0;i<199;i++)
	{
		CurrentPixelX=0;
		CurrentPixelY=i;
		OtherPixelX=239;
		OtherPixelY=199-i;

		DrawLine();
	}
}


void line_basic()
{
	unsigned char i;
	for (i=0;i<239;i++)
	{
		curset(i,0,3);
		draw(239-i-i,199,2);
	}
	for (i=0;i<199;i++)
	{
		curset(0,i,3);
		draw(239,199-i-i,2);
	}
}


void test()
{
	unsigned int delay;

	while (1)
	{
		// Mike routine first
		printf("\nMike: ");
		*(unsigned int*)0x276=0;
		line_mike();
		delay=65536-(*(unsigned int*)0x276);
		printf(" duration (in 100th of second): %d",delay);
		
		// Basic routine second
		printf("\nBasic: ");
		*(unsigned int*)0x276=0;
		line_basic();
		delay=65536-(*(unsigned int*)0x276);
		printf(" duration (in 100th of second): %d",delay);
	}
}


void main()
{	
	GenerateTables();
	hires();

	//memcpy((void*)0xa000,hires_image,hires_image_end-hires_image-1);

	//while (1);

	test();
}


